diff --git a/test/unit/claude_launcher_test.rb b/test/unit/claude_launcher_test.rb
index 1d6b2589..f0089527 100644
--- a/test/unit/claude_launcher_test.rb
+++ b/test/unit/claude_launcher_test.rb
@@ -895,6 +895,19 @@ class ClaudeLauncherTest < Minitest::Test
     File.read(File.expand_path("../fixtures/panes/#{name}", __dir__))
   end
 
+  # Advance Time.now by the sleep duration so floor/grace/deadline logic
+  # can be unit-tested without wall-clock waits.
+  def with_advancing_time
+    now = Time.now
+    with_replaced_singleton_method(Time, :now, -> { now }) do
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, lambda { |seconds|
+        now += [ seconds.to_f, 0.0 ].max
+      }) do
+        yield
+      end
+    end
+  end
+
   # Unify on the UnboundMethod capture+rebind stub pattern used in
   # brainstorm_tmux_sentinel_test.rb (Q1 / pr-test-analyzer #9). The
   # earlier `define_singleton_method` lambda-rebind approach could
@@ -917,6 +930,49 @@ class ClaudeLauncherTest < Minitest::Test
 
   public
 
+  def test_wait_until_session_exists_retries_transient_probe_errors
+    probes = 0
+    runner = Struct.new(:name) do
+      define_method(:session_exists?) do
+        probes += 1
+        raise Hive::TmuxError, "temporary has-session timeout" if probes == 1
+
+        true
+      end
+    end.new("starting-session")
+
+    with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, ->(_seconds) {}) do
+      assert_nil Hive::ClaudeLauncher.wait_until_session_exists!(runner)
+    end
+
+    assert_equal 2, probes
+  end
+
+  def test_wait_until_session_exists_reports_probe_error_after_deadline
+    probes = 0
+    runner = Struct.new(:name) do
+      define_method(:session_exists?) do
+        probes += 1
+        raise Hive::TmuxError, "has-session timed out"
+      end
+    end.new("unreadable-startup")
+    now = Time.now
+
+    with_replaced_singleton_method(Time, :now, -> { now }) do
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, lambda { |seconds|
+        now += seconds
+      }) do
+        err = assert_raises(Hive::AgentError) do
+          Hive::ClaudeLauncher.wait_until_session_exists!(runner)
+        end
+
+        assert_match(/did not start; last liveness probe failed: has-session timed out/, err.message)
+      end
+    end
+
+    assert_operator probes, :>, 1
+  end
+
   def test_prepare_claude_session_fails_when_session_disappears_before_ready
     runner = Struct.new(:name) do
       def session_exists? = false
@@ -1148,7 +1204,7 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
-  def test_wait_for_expected_output_treats_tmux_liveness_error_as_dead_session
+  def test_wait_for_expected_output_distinguishes_repeated_probe_errors_from_dead_session
     with_tmp_task do |task|
       output = File.join(task.folder, "missing.md")
       runner = Struct.new(:name) do
@@ -1160,7 +1216,8 @@ class ClaudeLauncherTest < Minitest::Test
       result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 10, output, "review")
 
       assert_equal :error, result.fetch(:status)
-      assert_match(/tmux_session_terminated/, result.fetch(:error_message))
+      assert_equal "tmux_session_probe_unreadable: server unavailable", result.fetch(:error_message)
+      refute_match(/tmux_session_terminated/, result.fetch(:error_message))
     end
   end
 
@@ -1196,6 +1253,28 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  def test_wait_for_expected_output_retries_a_transient_session_probe_error
+    with_tmp_task do |task|
+      output = File.join(task.folder, "result.md")
+      File.write(output, "review findings")
+      probes = 0
+      runner = Struct.new(:name, :tail) do
+        define_method(:session_exists?) do
+          probes += 1
+          raise Hive::TmuxError, "temporary has-session timeout" if probes == 1
+
+          true
+        end
+        def capture_pane_tail(bytes:) = tail
+      end.new("live-reviewer", "Claude Code v2\n❯")
+
+      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 10, output, "review")
+
+      assert_equal({ status: :ok, log_label: "review" }, result)
+      assert_equal 1, probes
+    end
+  end
+
   def test_wait_for_expected_output_times_out_when_file_missing
     with_tmp_task do |task|
       runner = Struct.new(:tail) do
@@ -1216,14 +1295,446 @@ class ClaudeLauncherTest < Minitest::Test
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "failed"))
 
       failed = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "ci")
-      assert_equal :failed, failed.fetch(:status)
+      assert_equal :error, failed.fetch(:status)
+      assert_equal :failed, failed.fetch(:reported_status)
       assert_match(/failed/, failed.fetch(:error_message))
+      assert_equal :done_file, failed.fetch(:stop_hook_signal)
+    end
+
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "cancelled"))
+
+      cancelled = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "ci")
+      assert_equal :error, cancelled.fetch(:status)
+      assert_equal :cancelled, cancelled.fetch(:reported_status)
+      assert_match(/cancelled/, cancelled.fetch(:error_message))
     end
 
     with_tmp_task do |task|
       timeout = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci")
       assert_equal :timeout, timeout.fetch(:status)
-      assert_match(/stop hook did not signal/, timeout.fetch(:error_message))
+      assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, timeout.fetch(:error_message)
+    end
+  end
+
+  def test_wait_for_done_signal_happy_path_records_done_file_signal
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "ci")
+
+      assert_equal :ok, result.fetch(:status)
+      assert_equal "ci", result.fetch(:log_label)
+      assert_equal :done_file, result.fetch(:stop_hook_signal)
+      refute result.key?(:completion_evidence)
+    end
+  end
+
+  def test_wait_for_done_signal_fallback_on_stable_ready_prompt
+    with_tmp_task do |task|
+      ready_checks = 0
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("alive-session", "Claude Code v2\n❯")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        # Shorter than the poll interval: with the required two ready polls,
+        # fallback can return only on the third readiness observation. A
+        # one-poll regression would return on the second observation.
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "0.05",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        original_ready = Hive::ClaudeLauncher.method(:claude_ready_prompt?)
+        counted_ready = lambda do |pane|
+          ready_checks += 1
+          original_ready.call(pane)
+        end
+        with_replaced_singleton_method(Hive::ClaudeLauncher, :claude_ready_prompt?, counted_ready) do
+          with_advancing_time do
+            result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 30, "review-fix")
+
+            assert_equal :ok, result.fetch(:status)
+            assert_equal "review-fix", result.fetch(:log_label)
+            assert_equal :missing, result.fetch(:stop_hook_signal)
+            assert_equal :ready_prompt, result.fetch(:completion_evidence)
+          end
+        end
+      end
+      assert_equal 2, Hive::ClaudeLauncher::STOP_HOOK_READY_STABLE_POLLS
+      assert_equal 3, ready_checks
+    end
+  end
+
+  def test_wait_for_done_signal_fallback_normalizes_failed_result_json
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "failed"))
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("failed-fallback", "Claude Code v2\n❯")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "1",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_advancing_time do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 30, "review-fix")
+
+          assert_equal :error, result.fetch(:status)
+          assert_equal :failed, result.fetch(:reported_status)
+          assert_equal :missing, result.fetch(:stop_hook_signal)
+          assert_equal :ready_prompt, result.fetch(:completion_evidence)
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_waits_for_in_flight_result_before_fallback
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.result_path(task), '{"status":"fail')
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("late-failed-hook", "Claude Code v2\n❯")
+
+      now = Time.now
+      sleeps = 0
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "0.05",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_replaced_singleton_method(Time, :now, -> { now }) do
+          with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, lambda { |seconds|
+            now += seconds
+            sleeps += 1
+            next unless sleeps == 3
+
+            File.write(
+              Hive::ClaudeLauncher.result_path(task),
+              JSON.generate("status" => "failed")
+            )
+            File.write(Hive::ClaudeLauncher.done_path(task), "done")
+          }) do
+            result = Hive::ClaudeLauncher.wait_for_done_signal(
+              task, runner, 30, "review-fix"
+            )
+
+            assert_equal :error, result.fetch(:status)
+            assert_equal :failed, result.fetch(:reported_status)
+            assert_equal :done_file, result.fetch(:stop_hook_signal)
+          end
+        end
+      end
+
+      assert_equal 3, sleeps
+      refute File.exist?(File.join(task.folder, "events.jsonl")),
+             "an in-flight hook that publishes .done must not be audited as a missing hook"
+    end
+  end
+
+  def test_wait_for_done_signal_fails_closed_on_malformed_result_after_done
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.result_path(task), '{"status":"fail')
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "review-fix")
+
+      assert_equal :error, result.fetch(:status)
+      assert_equal :done_file, result.fetch(:stop_hook_signal)
+      assert_match(/result\.json.*(?:incomplete|unreadable)/, result.fetch(:error_message))
+    end
+  end
+
+  def test_wait_for_done_signal_fallback_emits_audit_event
+    with_tmp_task(stage: "6-review") do |task|
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("hive-6-review-fix-pass1-slug", "Claude Code v2\n❯")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "1",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_advancing_time do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(
+            task, runner, 30, "review-fix-pass01"
+          )
+
+          assert_equal :ok, result.fetch(:status)
+          assert_equal :missing, result.fetch(:stop_hook_signal)
+
+          events_path = File.join(task.folder, "events.jsonl")
+          assert File.exist?(events_path), "fallback must append events.jsonl"
+          lines = File.readlines(events_path, chomp: true)
+          fallback_lines = lines.select { |line|
+            JSON.parse(line)["event_type"] == "claude_completion_fallback"
+          }
+          assert_equal 1, fallback_lines.size
+          parsed = JSON.parse(fallback_lines.first)
+          assert_equal "review-fix-pass01", parsed.fetch("agent")
+          assert_equal "6-review", parsed.fetch("stage")
+          assert_equal task.slug, parsed.fetch("slug")
+          msg = parsed.fetch("message")
+          assert_includes msg, "reason=stop_hook_missing_after_ready_prompt"
+          assert_includes msg, "sentinel=#{Hive::ClaudeLauncher.done_path(task)}"
+          assert_includes msg, "session=hive-6-review-fix-pass1-slug"
+          assert_includes msg, "result_json=absent"
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_done_file_does_not_emit_fallback_event
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "ci")
+
+      assert_equal :ok, result.fetch(:status)
+      assert_equal :done_file, result.fetch(:stop_hook_signal)
+      refute File.exist?(File.join(task.folder, "events.jsonl"))
+    end
+  end
+
+  def test_wait_for_done_signal_event_write_failure_does_not_change_ok
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("alive-session", "Claude Code v2\n❯")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "1",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_replaced_singleton_method(Hive::Events, :emit, ->(**_kwargs) { raise SystemCallError, "disk full" }) do
+          with_advancing_time do
+            _out, err = capture_io do
+              result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 30, "ci")
+
+              assert_equal :ok, result.fetch(:status)
+              assert_equal :missing, result.fetch(:stop_hook_signal)
+            end
+            assert_match(/claude_completion_fallback/, err)
+          end
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_late_hook_wins_during_grace
+    with_tmp_task do |task|
+      session_checks = 0
+      runner = Object.new
+      runner.define_singleton_method(:name) { "late-hook" }
+      runner.define_singleton_method(:session_exists?) do
+        session_checks += 1
+        # The third liveness probe runs after grace has elapsed, but after
+        # this loop iteration's initial `.done` check. Writing here proves
+        # the final grace-boundary recheck observes the late sentinel.
+        if session_checks == 3
+          File.write(Hive::ClaudeLauncher.done_path(task), "done")
+        end
+        true
+      end
+      runner.define_singleton_method(:capture_pane_tail) { |bytes:| "Claude Code v2\n❯" }
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "0.05",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_advancing_time do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 30, "ci")
+
+          assert_equal :ok, result.fetch(:status)
+          assert_equal :done_file, result.fetch(:stop_hook_signal)
+          refute result.key?(:completion_evidence)
+          assert_equal 3, session_checks
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_floor_guard_blocks_immediate_ready_fallback
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("alive-session", "Claude Code v2\n❯")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "60",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "1",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_advancing_time do
+          # Timeout well under the floor so ready-prompt fallback cannot arm.
+          result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 2, "ci")
+
+          assert_equal :timeout, result.fetch(:status)
+          assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, result.fetch(:error_message)
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_non_ready_pane_times_out_with_exact_message
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("busy-session", "Working on the fix…\nEditing lib/foo.rb")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "1",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_advancing_time do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 2, "ci")
+
+          assert_equal :timeout, result.fetch(:status)
+          assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, result.fetch(:error_message)
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_session_gone_without_done_is_attributed
+    with_tmp_task do |task|
+      runner = Struct.new(:name) do
+        def session_exists? = false
+      end.new("gone-session")
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, ->(_seconds) { flunk "must not wait to timeout" }) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "ci")
+
+        assert_equal :error, result.fetch(:status)
+        assert_equal Hive::ClaudeLauncher::STOP_HOOK_SESSION_TERMINATED_MESSAGE, result.fetch(:error_message)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_session_gone_with_done_still_ok
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      runner = Struct.new(:name) do
+        def session_exists? = false
+      end.new("gone-session")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "ci")
+
+      assert_equal :ok, result.fetch(:status)
+      assert_equal :done_file, result.fetch(:stop_hook_signal)
+    end
+  end
+
+  def test_wait_for_done_signal_retries_a_transient_session_probe_error
+    with_tmp_task do |task|
+      probes = 0
+      runner = Struct.new(:name, :tail) do
+        define_method(:session_exists?) do
+          probes += 1
+          raise Hive::TmuxError, "temporary has-session timeout" if probes == 1
+
+          true
+        end
+        def capture_pane_tail(bytes:) = tail
+      end.new("live-session", "busy")
+
+      replacement_sleep = lambda do |_seconds|
+        File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      end
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, replacement_sleep) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "ci")
+
+        assert_equal :ok, result.fetch(:status)
+        assert_equal :done_file, result.fetch(:stop_hook_signal)
+        assert_equal 1, probes
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_reports_repeated_session_probe_errors_without_calling_session_dead
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = raise Hive::TmuxError, "has-session timed out"
+        def capture_pane_tail(bytes:) = tail
+      end.new("unreadable-session", "busy")
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, ->(_seconds) {}) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "ci")
+
+        assert_equal :error, result.fetch(:status)
+        assert_equal "tmux_session_probe_unreadable: has-session timed out", result.fetch(:error_message)
+        refute_equal Hive::ClaudeLauncher::STOP_HOOK_SESSION_TERMINATED_MESSAGE,
+                     result.fetch(:error_message)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_reports_repeated_tmux_errors
+    with_tmp_task do |task|
+      runner = Struct.new(:name) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:)
+          raise Hive::TmuxError, "pane unreadable"
+        end
+      end.new("broken")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1",
+        # Disable fallback so this path only exercises pane-unreadable.
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "0"
+      ) do
+        with_advancing_time do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 30, "ci")
+
+          assert_equal :error, result.fetch(:status)
+          assert_match(/tmux_pane_unreadable: pane unreadable/, result.fetch(:error_message))
+        end
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_grace_zero_disables_fallback
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("alive-session", "Claude Code v2\n❯")
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_FALLBACK_FLOOR_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_STOP_HOOK_GRACE_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_SENTINEL_INTERVAL_SEC" => "0",
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.1"
+      ) do
+        with_advancing_time do
+          result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 2, "ci")
+
+          assert_equal :timeout, result.fetch(:status)
+          assert_equal Hive::ClaudeLauncher::STOP_HOOK_TIMEOUT_MESSAGE, result.fetch(:error_message)
+        end
+      end
     end
   end
 
@@ -1275,7 +1786,9 @@ class ClaudeLauncherTest < Minitest::Test
 
       result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "ci")
 
-      assert_equal({ status: :ok, log_label: "ci" }, result)
+      assert_equal :ok, result.fetch(:status)
+      assert_equal "ci", result.fetch(:log_label)
+      assert_equal :done_file, result.fetch(:stop_hook_signal)
       refute result.key?(:limit_text)
     end
   end
@@ -1285,7 +1798,8 @@ class ClaudeLauncherTest < Minitest::Test
       assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
 
       FileUtils.touch(Hive::ClaudeLauncher.result_path(task))
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_same Hive::ClaudeLauncher::RESULT_JSON_IN_FLIGHT,
+                  Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       assert_equal :ok, Hive::ClaudeLauncher.read_result_json_status(task)
@@ -1297,10 +1811,12 @@ class ClaudeLauncherTest < Minitest::Test
       assert_equal :cancelled, Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate([ "not", "a", "hash" ]))
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_same Hive::ClaudeLauncher::RESULT_JSON_IN_FLIGHT,
+                  Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), "{")
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_same Hive::ClaudeLauncher::RESULT_JSON_IN_FLIGHT,
+                  Hive::ClaudeLauncher.read_result_json_status(task)
     end
   end
 
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 9d5471ad..319c7187 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -48,6 +48,30 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_claude_completion_fallback_event_type_accepted
+    with_tmp_dir do |dir|
+      record = Hive::Events.emit(
+        task_folder: dir,
+        slug: "event-test-260522-aaaa",
+        stage: "6-review",
+        agent: "review-fix-pass01",
+        event_type: :claude_completion_fallback,
+        message: "reason=stop_hook_missing_after_ready_prompt sentinel=/tmp/.done"
+      )
+
+      assert_equal "claude_completion_fallback", record.fetch("event_type")
+      lines = File.readlines(File.join(dir, "events.jsonl"), chomp: true)
+      assert_equal 1, lines.size
+      parsed = JSON.parse(lines.first)
+      assert_equal "claude_completion_fallback", parsed.fetch("event_type")
+      assert_includes parsed.fetch("message"), "sentinel="
+
+      status = File.read(File.join(dir, "status.md"))
+      assert_includes status, "claude_completion_fallback"
+      assert_includes status, "review-fix-pass01"
+    end
+  end
+
   def test_status_md_rerenders_latest_event_and_recent_tail
     with_tmp_dir do |dir|
       Hive::Events.emit(task_folder: dir, slug: "event-test-260522-aaaa", stage: "6-review",
